/*
 *  
 *  Copyright (c) 2004 Steve Slaven, All Rights Reserved.
 *  
 *  This program is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU General Public License as
 *  published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *  
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *  GNU General Public License for more details.
 *  
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 *  MA 02111-1307 USA
 *  
*/
package net.hoopajoo.cheeselab3;
import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.util.*;

public class CheeseMapConfig extends JDialog implements ActionListener {
	JTextField username, server, port, loglevel;
	JPasswordField password;
	Properties props;
	
	CheeseMapConfig( Frame owner, Properties p ) {
		super( owner, true );
		
		props = p;
		username = new JTextField( p.getProperty( "userid" ) );
		server = new JTextField( p.getProperty( "server" ) );
		port = new JTextField( p.getProperty( "port" ) );
		loglevel = new JTextField( p.getProperty( "loglevel" ) );
		password = new JPasswordField( p.getProperty( "password" ) );
		password.setEchoChar( '*' );
		
		Container cpane = getContentPane();
		cpane.setLayout( new GridBagLayout() );
		GridBagConstraints c = new GridBagConstraints();
		c.fill = GridBagConstraints.HORIZONTAL;
		
		c.gridx = 0; c.gridy = 0;
		cpane.add( new JLabel( "Username" ), c );
		c.gridx = 1;
		cpane.add( username, c );
		
		c.gridx = 0; c.gridy++;
		cpane.add( new JLabel( "Password" ), c );
		c.gridx = 1;
		cpane.add( password, c );
		
		c.gridx = 0; c.gridy++;
		cpane.add( new JLabel( "Server" ), c );
		c.gridx = 1;
		cpane.add( server, c );

		c.gridx = 0; c.gridy++;
		cpane.add( new JLabel( "Port" ), c );
		c.gridx = 1;
		cpane.add( port, c );

		c.gridx = 0; c.gridy++;
		cpane.add( new JLabel( "Log Level" ), c );
		c.gridx = 1;
		cpane.add( loglevel, c );

		c.gridx = 0; c.gridy++; c.gridwidth = 2;
		JButton button;
		cpane.add( button = new JButton( "Save" ), c );
		button.addActionListener( this );
		
		pack();
	}
	
	public void actionPerformed( ActionEvent e ) {
		CheeseLab.dmesg( 3, "Woot!" );
		
		// copy values from the fields to the prop list
		props.setProperty( "userid", username.getText() );
		props.setProperty( "server", server.getText() );
		props.setProperty( "port", port.getText() );
		props.setProperty( "loglevel", loglevel.getText() );
		props.setProperty( "password", password.getText() );
		
		CheeseMap.apply_properties();
		CheeseMap.save_properties();
		hide();
		dispose();
	}
}
